/***************************************************************************
                          csound.cpp  -  description
                             -------------------
    begin                : Wed Apr 5 2000
    copyright            : (C) 2000 by Volker Schroer
    email                : huv.schroer@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "csound.h"
#include "parameter.h"
#include <cstdlib>

using namespace std;
extern Parameter settings;
CSound::CSound(int ptt = -1):Input(ptt)
{
started=false;
output=false;

}
CSound::~CSound()
{
/**
if ( audio_buffer.audiobuffer >0)
	delete audio_buffer.audiobuffer;
**/
}

int CSound::getSamples(double *sample,int anzahl)
{
 snd_pcm_sframes_t count;
 snd_pcm_uframes_t to_read;
 if(!started)
  return 0;
 to_read=anzahl-filled;
// count=snd_pcm_readi(handle,&buffer[4*filled],to_read);
 count=snd_pcm_readi(handle,&buffer[2*filled],to_read);
 if ( count < 0)
 {
   if( count == -EPIPE )
   {
    // Overrun
    snd_pcm_prepare(handle);
    snd_pcm_start(handle);
    printf("Overrun\n");
   }
  else
  {
   snd_pcm_drop(handle);
   started=false;
  }
  return 0;
 }
 filled +=count;

 if ( filled == anzahl )
 {
  double xmin,xmax;
  xmin=1.;
  xmax=-1.;
  int k,kk;
  double x;

  for(int i=0; i < anzahl; i++)
  {
   k=2*i;
   x=2*buffer[k];
   sample[i]=x;

  }
  filled=0;

  return anzahl;
 }
 else
  return 0;	
}
    
bool CSound::open_Device_read(QString *errorstring)
{
 int err;
 snd_pcm_hw_params_t *hwparams;
 snd_pcm_sw_params_t *swparams;
 snd_pcm_uframes_t period_size=1024;
 unsigned int SampleRate=11025;
// err = snd_pcm_open( &handle, "LinPSK", SND_PCM_STREAM_CAPTURE, SND_PCM_NONBLOCK );
 err = snd_pcm_open( &handle, "LinPSK_Record", SND_PCM_STREAM_CAPTURE, SND_PCM_NONBLOCK );
 if( err != 0)
 {
  *errorstring= QString("Unable to open Device LinPSK_Record: ")+ QString(snd_strerror(err));
  return false;
 }
  snd_pcm_hw_params_malloc(&hwparams);
  snd_pcm_sw_params_malloc(&swparams);

 /* Choose all parameters */
  err = snd_pcm_hw_params_any(handle, hwparams);
  if (err < 0)
  {
   *errorstring= QString("Broken configuration : no configurations available: ") + QString(snd_strerror(err));
   return false; 
  }
  /* Set the interleaved read/write format */
  err = snd_pcm_hw_params_set_access(handle, hwparams, SND_PCM_ACCESS_RW_INTERLEAVED);

  if (err < 0) 
  {
   *errorstring= QString("Access type not available : ") + QString(snd_strerror(err));
   return false;
  }
  /* Set the sample format */
 err = snd_pcm_hw_params_set_format(handle, hwparams, SND_PCM_FORMAT_FLOAT_LE);
 if (err < 0)
 {
  *errorstring= QString("Sample format Float not available : ") + QString(snd_strerror(err));
  return false;
 }
 /* Set the count of channels */
 err = snd_pcm_hw_params_set_channels(handle, hwparams, 2);
 if (err < 0)
 {
   *errorstring= QString("Channels count 2 not available, please modify your plugin: ") + QString(snd_strerror(err));
   return false;
 }

 err = snd_pcm_hw_params_set_rate(handle, hwparams, SampleRate, 0);
 if (err < 0)
 {
  *errorstring= QString("Samplerate %1 not available for capture: ").arg(SampleRate)+ QString(snd_strerror(err)); 
  return false;
 }
  int kkk=0;
  err = snd_pcm_hw_params_set_period_size_near(handle, hwparams, &period_size, &kkk);
  if (err < 0)
 {
   *errorstring= QString("Unable to set period size %d for play: ").arg(period_size) + QString(snd_strerror(err)); 
   return false;
  }
  snd_pcm_uframes_t buffer_size=9192;
  err = snd_pcm_hw_params_set_buffer_size_near(handle, hwparams, &buffer_size);
  if (err < 0)
  {
   *errorstring= QString("Unable to set buffer size %i for capture: ").arg(buffer_size) + QString(snd_strerror(err)); 
   return false;
   }
 err = snd_pcm_hw_params(handle, hwparams);
 if (err < 0) 
 {
  *errorstring= QString("Unable to set hw params for input: ") + QString(snd_strerror(err));
  return false;
 }
 snd_pcm_hw_params_free(hwparams);
 /* Get the current swparams */
 err = snd_pcm_sw_params_current(handle, swparams);
 if (err < 0)
 {
  *errorstring= QString("Unable to determine current swparams for capture: ") + QString(snd_strerror(err));
  return false;
 }

 err = snd_pcm_sw_params_set_start_threshold(handle, swparams, 1);
 if (err < 0)
 {
  *errorstring= QString("Unable to set start threshold for capture: ")  + QString(snd_strerror(err));
  return false;
 }

 /* Write the parameters to the record device */
  err = snd_pcm_sw_params(handle, swparams);
 if (err < 0)
 {
  *errorstring= QString("Unable to set sw params for input: ") + QString(snd_strerror(err));
  return false;
 }
 snd_pcm_sw_params_free(swparams);

 output=false;
 filled=0;
 err=snd_pcm_start(handle);
 if (err == 0)
  started=true;
 else 
 {
  *errorstring= QString("Unable to start soundcard for receiving: ") + QString(snd_strerror(err));
  started=false;
 }
 return started;
} 


bool CSound::open_Device_write(QString *errorstring)
{
 int err;
 snd_pcm_hw_params_t *hwparams;
 snd_pcm_sw_params_t *swparams;
 snd_pcm_uframes_t period_size=1024;
 unsigned int SampleRate=11025;
 err = snd_pcm_open( &handle, "LinPSK_Play", SND_PCM_STREAM_PLAYBACK, SND_PCM_NONBLOCK );
 if( err != 0)
 {
  *errorstring= QString("Unable to open Device LinPSK_Play: ")+ QString(snd_strerror(err));
  return false;
 }
  snd_pcm_hw_params_malloc(&hwparams);
  snd_pcm_sw_params_malloc(&swparams);

 /* Choose all parameters */
  err = snd_pcm_hw_params_any(handle, hwparams);
  if (err < 0)
  {
   *errorstring= QString("Broken configuration : no configurations available: ") + QString(snd_strerror(err));
   return false; 
  }
  /* Set the interleaved read/write format */
  err = snd_pcm_hw_params_set_access(handle, hwparams, SND_PCM_ACCESS_RW_INTERLEAVED);

  if (err < 0) 
  {
   *errorstring= QString("Access type not available : ") + QString(snd_strerror(err));
   return false;
  }
  /* Set the sample format */
 err = snd_pcm_hw_params_set_format(handle, hwparams, SND_PCM_FORMAT_FLOAT_LE);
 if (err < 0)
 {
  *errorstring= QString("Sample format Float not available : ") + QString(snd_strerror(err));
  return false;
 }
 /* Set the count of channels */
 err = snd_pcm_hw_params_set_channels(handle, hwparams, 2);
 if (err < 0)
 {
   *errorstring= QString("Channels count 2 not available, please modify your plugin: ") + QString(snd_strerror(err));
   return false;
 }

 err = snd_pcm_hw_params_set_rate(handle, hwparams, SampleRate, 0);
 if (err < 0)
 {
  *errorstring= QString("Samplerate %1 not available for playing: ").arg(SampleRate)+ QString(snd_strerror(err)); 
  return false;
 }
  int kkk=0;
  err = snd_pcm_hw_params_set_period_size_near(handle, hwparams, &period_size, &kkk);
  if (err < 0)
 {
   *errorstring= QString("Unable to set period size %d for play: ").arg(period_size) + QString(snd_strerror(err)); 
   return false;
  }
  snd_pcm_uframes_t buffer_size=9192;
  err = snd_pcm_hw_params_set_buffer_size_near(handle, hwparams, &buffer_size);
  if (err < 0)
  {
   *errorstring= QString("Unable to set buffer size %i for play: ").arg(buffer_size) + QString(snd_strerror(err)); 
   return false;
   }
 err = snd_pcm_hw_params(handle, hwparams);
 if (err < 0) 
 {
  *errorstring= QString("Unable to set hw params for input: ") + QString(snd_strerror(err));
  return false;
 }
 snd_pcm_hw_params_free(hwparams);
 /* Get the current swparams */
 err = snd_pcm_sw_params_current(handle, swparams);
 if (err < 0)
 {
  *errorstring= QString("Unable to determine current swparams for play: ") + QString(snd_strerror(err));
  return false;
 }
 err = snd_pcm_sw_params_set_start_threshold(handle, swparams, 2048);
 if (err < 0)
 {
  printf("Unable to set start threshold mode : %s\n",snd_strerror(err));
  return false;
 }
 /* Write the parameters to the record/playback device */
 err = snd_pcm_sw_params(handle, swparams);
 if (err < 0)
 {
  printf("Unable to set sw params for output: %s\n",snd_strerror(err));
  return false;
 }
 filled=0;
 output=true;
 return true;
}

int CSound::putSamples(double *sample,int anzahl)
{
 int err,laenge;
 if(filled == 0 )
  for(int i=0;i < anzahl;i++)
  {
   buffer[2*i]=sample[i];
   buffer[2*i+1]=sample[i];
  }
 laenge=anzahl-filled; // It's stereo
 err =  snd_pcm_writei(handle,&buffer[2*filled], laenge);
 if( err > 0 )
 {
  if (err == laenge)
  {
   filled=0;
   laenge=anzahl;
  }
  else
  {
   filled += err;
   laenge=0;
  }
 }
 else if ( err == 0 )
   printf("0 bytes written\n");
 else
 {
   if (err ==  -EAGAIN)
    laenge=0;
   else if (err == -EPIPE)
   {    /* under-run */
    printf("Underun in Play position 2 laenge %d  available %d\n",laenge,anzahl);
    err = snd_pcm_prepare(handle);
    if (err < 0)
    {
     printf("Can't recover from underrun, prepare failed: %s\n", snd_strerror(err));
     return -1;
    }
   } else
   {
     printf("Unhandled error in play %s\n",snd_strerror(err));
     snd_pcm_drop(handle);
   }
  laenge=0;
 }
 return laenge;
}

void CSound::PTT(bool mode)
{
int flags;
int ii;
flags= TIOCM_RTS|TIOCM_DTR;
if (serial <0) // No serial Device selected
{
 // No PTT, only start stream
 if (mode)
  {
   if ( !started ) 
   {
//    Pa_StartStream(stream);
    started = true;
   }
  } 
 else
  { 
   if ( started ) 
   {
//    Pa_AbortStream(stream);
    started = false;
   }
  }  
 return;
} 
if (mode)		// PTT on
{	
 ii=ioctl(serial,TIOCMBIS,&flags);
 if ( !started ) 
   {
//    Pa_StartStream(stream);
    started = true;
   }
} 
else
 {
     if ( started ) 
   {
//    Pa_AbortStream(stream);
    started = false;
   } 
  ii=ioctl(serial,TIOCMBIC,&flags);
 } 
return;
}

bool CSound::close_Device()
{
//if (started)
if (output)
{ 
  // Wait for AudioBuffer to get empty
// while (audio_buffer.available> 0 )
  usleep(10000);
}
 if(handle != 0)
  snd_pcm_close(handle);
 handle=0;
   
started=false;
output = false;
return true;
}


