/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
#include <qmessagebox.h>
#include <qwidget.h>
#include <qdir.h>
#include <qstringlist.h>

extern Parameter settings;

Parameter GeneralSettings::getSettings()
{
LocalSettings.callsign=Callsign->text();
if(Demomode->isOn() )
 {
   LocalSettings.DemoMode=true;
   LocalSettings.DemoTypeNumber=Fileformat->id(Fileformat->selected());
   LocalSettings.inputFilename="";
  }
else
   LocalSettings.DemoMode=false;
  
LocalSettings.timeoffset=UTC->value();
if( SlashedZero->isOn())
  LocalSettings.slashed0=true;
else
  LocalSettings.slashed0=false;
LocalSettings.SerialDevice=SelectedDevice->text();
LocalSettings.QSOFileName=QsoFile->text();
return LocalSettings;
}

void GeneralSettings::init()
{
QString Directory;
QDir dir;
//connect(Output,SIGNAL(valueChanged(int)),this,SIGNAL(OutputLevelChanged(int)));
LocalSettings = settings;    


Callsign->setText(LocalSettings.callsign);
UTC->setValue(LocalSettings.timeoffset);
SlashedZero->setChecked(LocalSettings.slashed0);

Demomode->setChecked(LocalSettings.DemoMode);

Fileformat->setButton(LocalSettings.DemoTypeNumber);
if (Demomode->isOn())
    Fileformat->show();
else
    Fileformat->hide();

//PTT
SelectedDevice->setText(LocalSettings.SerialDevice);
// First look in the /dev Directory
Directory="/dev/";

dir.setPath(Directory);
#ifndef LINPSK_FOR_MAC
QStringList Files=dir.entryList("ttyS*",QDir::Files|QDir::System,QDir::Name);
#else
QStringList Files=dir.entryList("*usbserial*",QDir::Files|QDir::System,QDir::Name);
#endif
for(QStringList::iterator Name=Files.begin();Name !=Files.end(); Name++)
 AvailableDevices->insertItem(Directory + *Name); 
#ifdef LINPSK_FOR_MAC
Files=dir.entryList("cu.*",QDir::Files|QDir::System,QDir::Name);
for(QStringList::iterator Name=Files.begin();Name !=Files.end(); Name++)
 AvailableDevices->insertItem(Directory + *Name); 
#endif
// Now check for usb devices 
Directory="/dev/usb/tts/";
dir.setPath(Directory);
Files=dir.entryList(QDir::Files|QDir::System,QDir::Name); 
 
for(QStringList::iterator Name=Files.begin();Name !=Files.end(); Name++)
 AvailableDevices->insertItem(Directory + *Name); 

QsoFile->setText(LocalSettings.QSOFileName);
selectDemomode();
}


void GeneralSettings::GeneralSettings_destroyed( QObject * )
{

}


void GeneralSettings::selectDemomode()
{
if (Demomode->isOn())
     Fileformat->show();
else
     Fileformat->hide();
}

void GeneralSettings::selectComPort(const QString &s)
{


SelectedDevice->clear();
SelectedDevice->setText(s);
}

